using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace DisplayingFormsCSharp
{
	[StructLayout(LayoutKind.Sequential)]
	public struct BaseUnits
	{
		public short Width;
		public short Height;
	}

	public class Calculator : System.Windows.Forms.Form
	{

		[DllImport("User32.dll")]
		public static extern BaseUnits GetDialogBaseUnits();

		[DllImport("gdi32.dll")]
		private static extern long BitBlt (IntPtr hdcDest,int nXDest, int nYDest, int nWidth, int nHeight,
			IntPtr hdcSrc, int nXSrc, int nYSrc, System.Int32 dwRop);

		Bitmap memoryImage;
		
		internal System.Drawing.Printing.PrintDocument PrintDocument1;
		internal System.Windows.Forms.Panel pnlSystemDU;
		internal System.Windows.Forms.TextBox tbMenuFont;
		internal System.Windows.Forms.Label Label16;
		internal System.Windows.Forms.TextBox tbSysVDU;
		internal System.Windows.Forms.Label Label15;
		internal System.Windows.Forms.TextBox tbSysHDU;
		internal System.Windows.Forms.Label Label14;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.ComboBox cbFace;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.ComboBox cbStyle;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.ComboBox cbSize;
		internal System.Windows.Forms.Panel Panel1;
		internal System.Windows.Forms.TextBox tbUnrelated;
		internal System.Windows.Forms.TextBox tbRelated;
		internal System.Windows.Forms.TextBox tbLabel;
		internal System.Windows.Forms.TextBox tbMargins;
		internal System.Windows.Forms.TextBox tbButton;
		internal System.Windows.Forms.TextBox tbGrid;
		internal System.Windows.Forms.TextBox tbVDU;
		internal System.Windows.Forms.TextBox tbHDU;
		internal System.Windows.Forms.TextBox tbHeight;
		internal System.Windows.Forms.TextBox tbAvgWidth;
		internal System.Windows.Forms.Label Label13;
		internal System.Windows.Forms.Label Label12;
		internal System.Windows.Forms.Label Label11;
		internal System.Windows.Forms.Label Label10;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.Label Label8;
		internal System.Windows.Forms.Label Label7;
		internal System.Windows.Forms.Label Label6;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.Button btnPrint;
		internal System.Windows.Forms.Button btnRecalc;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Calculator()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			for (int x = 0; x < FontFamily.Families.Length; x++)
				this.cbFace.Items.Add(FontFamily.Families[x].Name);
			this.cbFace.SelectedIndex = 0;

			this.cbStyle.SelectedIndex = 0;
			this.cbSize.SelectedIndex = 0;

			BaseUnits dlu = GetDialogBaseUnits();

			this.tbSysHDU.Text = System.Convert.ToString((dlu.Height / 8),10);
			this.tbSysVDU.Text = System.Convert.ToString((dlu.Width / 4),10);

			tbMenuFont.Text = SystemInformation.MenuFont.Size + " point ";
			tbMenuFont.Text += SystemInformation.MenuFont.Name;


		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.PrintDocument1 = new System.Drawing.Printing.PrintDocument();
			this.pnlSystemDU = new System.Windows.Forms.Panel();
			this.tbMenuFont = new System.Windows.Forms.TextBox();
			this.Label16 = new System.Windows.Forms.Label();
			this.tbSysVDU = new System.Windows.Forms.TextBox();
			this.Label15 = new System.Windows.Forms.Label();
			this.tbSysHDU = new System.Windows.Forms.TextBox();
			this.Label14 = new System.Windows.Forms.Label();
			this.Label3 = new System.Windows.Forms.Label();
			this.cbFace = new System.Windows.Forms.ComboBox();
			this.Label2 = new System.Windows.Forms.Label();
			this.cbStyle = new System.Windows.Forms.ComboBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.cbSize = new System.Windows.Forms.ComboBox();
			this.Panel1 = new System.Windows.Forms.Panel();
			this.tbUnrelated = new System.Windows.Forms.TextBox();
			this.tbRelated = new System.Windows.Forms.TextBox();
			this.tbLabel = new System.Windows.Forms.TextBox();
			this.tbMargins = new System.Windows.Forms.TextBox();
			this.tbButton = new System.Windows.Forms.TextBox();
			this.tbGrid = new System.Windows.Forms.TextBox();
			this.tbVDU = new System.Windows.Forms.TextBox();
			this.tbHDU = new System.Windows.Forms.TextBox();
			this.tbHeight = new System.Windows.Forms.TextBox();
			this.tbAvgWidth = new System.Windows.Forms.TextBox();
			this.Label13 = new System.Windows.Forms.Label();
			this.Label12 = new System.Windows.Forms.Label();
			this.Label11 = new System.Windows.Forms.Label();
			this.Label10 = new System.Windows.Forms.Label();
			this.Label9 = new System.Windows.Forms.Label();
			this.Label8 = new System.Windows.Forms.Label();
			this.Label7 = new System.Windows.Forms.Label();
			this.Label6 = new System.Windows.Forms.Label();
			this.Label5 = new System.Windows.Forms.Label();
			this.Label4 = new System.Windows.Forms.Label();
			this.btnPrint = new System.Windows.Forms.Button();
			this.btnRecalc = new System.Windows.Forms.Button();
			this.pnlSystemDU.SuspendLayout();
			this.Panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// PrintDocument1
			// 
			this.PrintDocument1.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.PrintDocument1_PrintPage);
			// 
			// pnlSystemDU
			// 
			this.pnlSystemDU.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlSystemDU.Controls.Add(this.tbMenuFont);
			this.pnlSystemDU.Controls.Add(this.Label16);
			this.pnlSystemDU.Controls.Add(this.tbSysVDU);
			this.pnlSystemDU.Controls.Add(this.Label15);
			this.pnlSystemDU.Controls.Add(this.tbSysHDU);
			this.pnlSystemDU.Controls.Add(this.Label14);
			this.pnlSystemDU.Location = new System.Drawing.Point(8, 336);
			this.pnlSystemDU.Name = "pnlSystemDU";
			this.pnlSystemDU.Size = new System.Drawing.Size(472, 64);
			this.pnlSystemDU.TabIndex = 19;
			// 
			// tbMenuFont
			// 
			this.tbMenuFont.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbMenuFont.Location = new System.Drawing.Point(136, 32);
			this.tbMenuFont.Name = "tbMenuFont";
			this.tbMenuFont.Size = new System.Drawing.Size(320, 20);
			this.tbMenuFont.TabIndex = 25;
			this.tbMenuFont.Text = "";
			// 
			// Label16
			// 
			this.Label16.AutoSize = true;
			this.Label16.Location = new System.Drawing.Point(48, 32);
			this.Label16.Name = "Label16";
			this.Label16.Size = new System.Drawing.Size(61, 16);
			this.Label16.TabIndex = 24;
			this.Label16.Text = "Menu Font:";
			// 
			// tbSysVDU
			// 
			this.tbSysVDU.Location = new System.Drawing.Point(352, 8);
			this.tbSysVDU.Name = "tbSysVDU";
			this.tbSysVDU.TabIndex = 23;
			this.tbSysVDU.Text = "";
			// 
			// Label15
			// 
			this.Label15.AutoSize = true;
			this.Label15.Location = new System.Drawing.Point(264, 8);
			this.Label15.Name = "Label15";
			this.Label15.Size = new System.Drawing.Size(70, 16);
			this.Label15.TabIndex = 22;
			this.Label15.Text = "System vDU:";
			// 
			// tbSysHDU
			// 
			this.tbSysHDU.Location = new System.Drawing.Point(136, 8);
			this.tbSysHDU.Name = "tbSysHDU";
			this.tbSysHDU.TabIndex = 21;
			this.tbSysHDU.Text = "";
			// 
			// Label14
			// 
			this.Label14.AutoSize = true;
			this.Label14.Location = new System.Drawing.Point(48, 8);
			this.Label14.Name = "Label14";
			this.Label14.Size = new System.Drawing.Size(71, 16);
			this.Label14.TabIndex = 20;
			this.Label14.Text = "System hDU:";
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Location = new System.Drawing.Point(408, 8);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(29, 16);
			this.Label3.TabIndex = 12;
			this.Label3.Text = "Size:";
			// 
			// cbFace
			// 
			this.cbFace.DropDownStyle = System.Windows.Forms.ComboBoxStyle.Simple;
			this.cbFace.Location = new System.Drawing.Point(8, 24);
			this.cbFace.Name = "cbFace";
			this.cbFace.Size = new System.Drawing.Size(272, 160);
			this.cbFace.TabIndex = 13;
			this.cbFace.Text = "Face";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Location = new System.Drawing.Point(296, 8);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(33, 16);
			this.Label2.TabIndex = 11;
			this.Label2.Text = "Style:";
			// 
			// cbStyle
			// 
			this.cbStyle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.Simple;
			this.cbStyle.Items.AddRange(new object[] {
														 "Regular",
														 "Italic",
														 "Bold",
														 "Bold Italic"});
			this.cbStyle.Location = new System.Drawing.Point(296, 24);
			this.cbStyle.Name = "cbStyle";
			this.cbStyle.Size = new System.Drawing.Size(96, 160);
			this.cbStyle.TabIndex = 14;
			this.cbStyle.Text = "Style";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(8, 8);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(33, 16);
			this.Label1.TabIndex = 10;
			this.Label1.Text = "Face:";
			// 
			// cbSize
			// 
			this.cbSize.DropDownStyle = System.Windows.Forms.ComboBoxStyle.Simple;
			this.cbSize.Items.AddRange(new object[] {
														"8",
														"9",
														"10",
														"11",
														"12",
														"14",
														"16",
														"18",
														"20",
														"22",
														"24",
														"26",
														"28",
														"36",
														"48",
														"72"});
			this.cbSize.Location = new System.Drawing.Point(408, 24);
			this.cbSize.Name = "cbSize";
			this.cbSize.Size = new System.Drawing.Size(72, 160);
			this.cbSize.TabIndex = 15;
			this.cbSize.Text = "Size";
			// 
			// Panel1
			// 
			this.Panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Panel1.Controls.Add(this.tbUnrelated);
			this.Panel1.Controls.Add(this.tbRelated);
			this.Panel1.Controls.Add(this.tbLabel);
			this.Panel1.Controls.Add(this.tbMargins);
			this.Panel1.Controls.Add(this.tbButton);
			this.Panel1.Controls.Add(this.tbGrid);
			this.Panel1.Controls.Add(this.tbVDU);
			this.Panel1.Controls.Add(this.tbHDU);
			this.Panel1.Controls.Add(this.tbHeight);
			this.Panel1.Controls.Add(this.tbAvgWidth);
			this.Panel1.Controls.Add(this.Label13);
			this.Panel1.Controls.Add(this.Label12);
			this.Panel1.Controls.Add(this.Label11);
			this.Panel1.Controls.Add(this.Label10);
			this.Panel1.Controls.Add(this.Label9);
			this.Panel1.Controls.Add(this.Label8);
			this.Panel1.Controls.Add(this.Label7);
			this.Panel1.Controls.Add(this.Label6);
			this.Panel1.Controls.Add(this.Label5);
			this.Panel1.Controls.Add(this.Label4);
			this.Panel1.Location = new System.Drawing.Point(8, 184);
			this.Panel1.Name = "Panel1";
			this.Panel1.Size = new System.Drawing.Size(472, 144);
			this.Panel1.TabIndex = 18;
			// 
			// tbUnrelated
			// 
			this.tbUnrelated.Location = new System.Drawing.Point(352, 104);
			this.tbUnrelated.Name = "tbUnrelated";
			this.tbUnrelated.TabIndex = 28;
			this.tbUnrelated.Text = "";
			// 
			// tbRelated
			// 
			this.tbRelated.Location = new System.Drawing.Point(352, 80);
			this.tbRelated.Name = "tbRelated";
			this.tbRelated.TabIndex = 27;
			this.tbRelated.Text = "";
			// 
			// tbLabel
			// 
			this.tbLabel.Location = new System.Drawing.Point(352, 56);
			this.tbLabel.Name = "tbLabel";
			this.tbLabel.TabIndex = 26;
			this.tbLabel.Text = "";
			// 
			// tbMargins
			// 
			this.tbMargins.Location = new System.Drawing.Point(352, 32);
			this.tbMargins.Name = "tbMargins";
			this.tbMargins.TabIndex = 25;
			this.tbMargins.Text = "";
			// 
			// tbButton
			// 
			this.tbButton.Location = new System.Drawing.Point(352, 8);
			this.tbButton.Name = "tbButton";
			this.tbButton.TabIndex = 24;
			this.tbButton.Text = "";
			// 
			// tbGrid
			// 
			this.tbGrid.Location = new System.Drawing.Point(136, 104);
			this.tbGrid.Name = "tbGrid";
			this.tbGrid.TabIndex = 23;
			this.tbGrid.Text = "";
			// 
			// tbVDU
			// 
			this.tbVDU.Location = new System.Drawing.Point(136, 80);
			this.tbVDU.Name = "tbVDU";
			this.tbVDU.TabIndex = 22;
			this.tbVDU.Text = "";
			// 
			// tbHDU
			// 
			this.tbHDU.Location = new System.Drawing.Point(136, 56);
			this.tbHDU.Name = "tbHDU";
			this.tbHDU.TabIndex = 21;
			this.tbHDU.Text = "";
			// 
			// tbHeight
			// 
			this.tbHeight.Location = new System.Drawing.Point(136, 32);
			this.tbHeight.Name = "tbHeight";
			this.tbHeight.TabIndex = 20;
			this.tbHeight.Text = "";
			// 
			// tbAvgWidth
			// 
			this.tbAvgWidth.Location = new System.Drawing.Point(136, 8);
			this.tbAvgWidth.Name = "tbAvgWidth";
			this.tbAvgWidth.TabIndex = 19;
			this.tbAvgWidth.Text = "";
			// 
			// Label13
			// 
			this.Label13.AutoSize = true;
			this.Label13.Location = new System.Drawing.Point(240, 106);
			this.Label13.Name = "Label13";
			this.Label13.TabIndex = 18;
			this.Label13.Text = "Unrelated Widgets:";
			// 
			// Label12
			// 
			this.Label12.AutoSize = true;
			this.Label12.Location = new System.Drawing.Point(248, 82);
			this.Label12.Name = "Label12";
			this.Label12.Size = new System.Drawing.Size(90, 16);
			this.Label12.TabIndex = 17;
			this.Label12.Text = "Related Widgets:";
			// 
			// Label11
			// 
			this.Label11.AutoSize = true;
			this.Label11.Location = new System.Drawing.Point(256, 58);
			this.Label11.Name = "Label11";
			this.Label11.Size = new System.Drawing.Size(82, 16);
			this.Label11.TabIndex = 16;
			this.Label11.Text = "Label Distance:";
			// 
			// Label10
			// 
			this.Label10.AutoSize = true;
			this.Label10.Location = new System.Drawing.Point(288, 34);
			this.Label10.Name = "Label10";
			this.Label10.Size = new System.Drawing.Size(48, 16);
			this.Label10.TabIndex = 15;
			this.Label10.Text = "Margins:";
			// 
			// Label9
			// 
			this.Label9.AutoSize = true;
			this.Label9.Location = new System.Drawing.Point(272, 10);
			this.Label9.Name = "Label9";
			this.Label9.Size = new System.Drawing.Size(65, 16);
			this.Label9.TabIndex = 14;
			this.Label9.Text = "Button Size:";
			// 
			// Label8
			// 
			this.Label8.AutoSize = true;
			this.Label8.Location = new System.Drawing.Point(24, 106);
			this.Label8.Name = "Label8";
			this.Label8.Size = new System.Drawing.Size(109, 16);
			this.Label8.TabIndex = 13;
			this.Label8.Text = "Recommended Grid:";
			// 
			// Label7
			// 
			this.Label7.AutoSize = true;
			this.Label7.Location = new System.Drawing.Point(96, 82);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(29, 16);
			this.Label7.TabIndex = 12;
			this.Label7.Text = "vDU:";
			// 
			// Label6
			// 
			this.Label6.AutoSize = true;
			this.Label6.Location = new System.Drawing.Point(96, 58);
			this.Label6.Name = "Label6";
			this.Label6.Size = new System.Drawing.Size(30, 16);
			this.Label6.TabIndex = 11;
			this.Label6.Text = "hDU:";
			// 
			// Label5
			// 
			this.Label5.AutoSize = true;
			this.Label5.Location = new System.Drawing.Point(40, 34);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(93, 16);
			this.Label5.TabIndex = 10;
			this.Label5.Text = "Character Height:";
			// 
			// Label4
			// 
			this.Label4.AutoSize = true;
			this.Label4.Location = new System.Drawing.Point(16, 10);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(112, 16);
			this.Label4.TabIndex = 9;
			this.Label4.Text = "Avg Character Width:";
			// 
			// btnPrint
			// 
			this.btnPrint.Location = new System.Drawing.Point(496, 40);
			this.btnPrint.Name = "btnPrint";
			this.btnPrint.Size = new System.Drawing.Size(88, 23);
			this.btnPrint.TabIndex = 17;
			this.btnPrint.Text = "Print";
			this.btnPrint.Click += new System.EventHandler(this.btnPrint_Click);
			// 
			// btnRecalc
			// 
			this.btnRecalc.Location = new System.Drawing.Point(496, 8);
			this.btnRecalc.Name = "btnRecalc";
			this.btnRecalc.Size = new System.Drawing.Size(88, 23);
			this.btnRecalc.TabIndex = 16;
			this.btnRecalc.Text = "Calculate";
			this.btnRecalc.Click += new System.EventHandler(this.btnRecalc_Click);
			// 
			// Calculator
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(616, 413);
			this.Controls.Add(this.Label3);
			this.Controls.Add(this.cbFace);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.cbStyle);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.cbSize);
			this.Controls.Add(this.Panel1);
			this.Controls.Add(this.btnPrint);
			this.Controls.Add(this.btnRecalc);
			this.Controls.Add(this.pnlSystemDU);
			this.Name = "Calculator";
			this.Text = "Calculator";
			this.pnlSystemDU.ResumeLayout(false);
			this.Panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnRecalc_Click(object sender, System.EventArgs e)
		{
			Font theFont;
			String theFamily = (string)this.cbFace.SelectedItem;
			FontStyle theStyle;
			float theSize = (float)Convert.ToDouble(this.cbSize.SelectedItem);

			theStyle = (FontStyle)Enum.Parse(typeof(FontStyle), (string)this.cbStyle.SelectedItem);
			theFont = new Font(theFamily, theSize, theStyle, GraphicsUnit.Pixel);

			float hDU = theFont.Size / 4;
			float vDU = theFont.Size / 8;
			double rndHDU = Math.Round(hDU);
			double rndVDU = Math.Round(vDU);

			this.tbAvgWidth.Text = (theFont.Size).ToString();
			this.tbHeight.Text = (theFont.Height).ToString();
			this.tbHDU.Text = hDU.ToString();
			this.tbVDU.Text = vDU.ToString();
			this.tbGrid.Text = rndHDU + "h x " + rndVDU + "v";
			this.tbButton.Text = (rndHDU * 14) + "h x 50v";
			this.tbMargins.Text = (rndHDU * 7) + "h x " + (rndVDU * 7) + "v";
			this.tbLabel.Text = (rndHDU * 3).ToString();
			this.tbRelated.Text = (rndHDU * 4).ToString();
			this.tbUnrelated.Text = (rndHDU * 7).ToString();

		}

		private void CaptureScreen()
		{
			Graphics mygraphics = this.CreateGraphics();
			Size s = this.Size;
			
			memoryImage = new Bitmap(s.Width, s.Height, mygraphics);
			Graphics memoryGraphics = Graphics.FromImage(memoryImage);
			IntPtr dc1 = mygraphics.GetHdc();
			IntPtr dc2 = memoryGraphics.GetHdc();

			BitBlt(dc2, 0, 0, this.ClientRectangle.Width, this.ClientRectangle.Height, dc1, 0, 0, 13369376);
			mygraphics.ReleaseHdc(dc1);
			memoryGraphics.ReleaseHdc(dc2);
		}

		private void PrintDocument1_PrintPage(System.Object sender,System.Drawing.Printing.PrintPageEventArgs e) 
		{
			e.Graphics.DrawImage(memoryImage, 0, 0);
		}

		private void btnPrint_Click(object sender, System.EventArgs e)
		{
			CaptureScreen();
			PrintDocument1.Print();
		}

	}
}
