Public Class Configure
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
        AddRows()

        Me.Label1.Font = MakeFont("DisplayFontName", "DisplayFontSize")
        Me.Label1.ForeColor = MakeColor("ForeColorRed", "ForeColorGreen", "ForeColorBlue")

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents dsUserSettings As UserCustomizationVB.UserSettings
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label
        Me.dsUserSettings = New UserCustomizationVB.UserSettings
        CType(Me.dsUserSettings, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(24, 16)
        Me.Label1.Name = "Label1"
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Label1"
        '
        'dsUserSettings
        '
        Me.dsUserSettings.DataSetName = "UserSettings"
        Me.dsUserSettings.Locale = New System.Globalization.CultureInfo("en-US")
        '
        'Configure
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(368, 62)
        Me.Controls.Add(Me.Label1)
        Me.Name = "Configure"
        Me.Text = "Configure"
        CType(Me.dsUserSettings, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub AddRows()
        Dim newRow As UserSettings.DisplayPropertiesRow

        newRow = Me.dsUserSettings.DisplayProperties.NewDisplayPropertiesRow
        With newRow
            .UserName = "Admin"
            .PropertyName = "DisplayFontName"
            .PropertyValue = "Tempus Sans ITC"
        End With
        Me.dsUserSettings.DisplayProperties.Rows.Add(newRow)

        newRow = Me.dsUserSettings.DisplayProperties.NewDisplayPropertiesRow
        With newRow
            .UserName = "Admin"
            .PropertyName = "DisplayFontSize"
            .PropertyValue = "8.2"
        End With
        Me.dsUserSettings.DisplayProperties.Rows.Add(newRow)

        newRow = Me.dsUserSettings.DisplayProperties.NewDisplayPropertiesRow
        With newRow
            .UserName = "Admin"
            .PropertyName = "ForeColorRed"
            .PropertyValue = "255"
        End With
        Me.dsUserSettings.DisplayProperties.Rows.Add(newRow)

        newRow = Me.dsUserSettings.DisplayProperties.NewDisplayPropertiesRow
        With newRow
            .UserName = "Admin"
            .PropertyName = "ForeColorGreen"
            .PropertyValue = "0"
        End With
        Me.dsUserSettings.DisplayProperties.Rows.Add(newRow)

        newRow = Me.dsUserSettings.DisplayProperties.NewDisplayPropertiesRow
        With newRow
            .UserName = "Admin"
            .PropertyName = "ForeColorBlue"
            .PropertyValue = "0"
        End With
        Me.dsUserSettings.DisplayProperties.Rows.Add(newRow)

    End Sub

    Private Function MakeFont(ByVal theName As String, ByVal theSize As String) As Font
        Dim curRowIdx As Integer

        With Me.dsUserSettings.DisplayProperties
            .DefaultView.Sort = "PropertyName"

            Dim fontName As String
            curRowIdx = .DefaultView.Find(theName)
            fontName = .Rows(curRowIdx).Item("PropertyValue")


            Dim fontSize As Single
            curRowIdx = .DefaultView.Find(theSize)
            fontSize = CType(.Rows(curRowIdx).Item("PropertyValue"), Single)

            Return New Font(fontName, fontSize)

        End With
    End Function

    Private Function MakeColor(ByVal theRed As String, ByVal theGreen As String, ByVal theBlue As String) As Color
        Dim curRowIdx As Integer

        With Me.dsUserSettings.DisplayProperties
            .DefaultView.Sort = "PropertyName"

            Dim clrRed As Integer
            curRowIdx = .DefaultView.Find(theRed)
            clrRed = CType(.Rows(curRowIdx).Item("PropertyValue"), Integer)

            Dim clrGreen As Integer
            curRowIdx = .DefaultView.Find(theGreen)
            clrGreen = CType(.Rows(curRowIdx).Item("PropertyValue"), Integer)

            Dim clrBlue As Integer
            curRowIdx = .DefaultView.Find(theBlue)
            clrBlue = CType(.Rows(curRowIdx).Item("PropertyValue"), Integer)

            Return Color.FromArgb(clrRed, clrGreen, clrBlue)
        End With

    End Function


End Class
