using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Typography
{
	/// <summary>
	/// Summary description for DrawStrings.
	/// </summary>
	public class DrawStrings : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Button btnLineAlignment;
		internal System.Windows.Forms.Button btnAlignment;
		internal System.Windows.Forms.Button btnRect;
		internal System.Windows.Forms.Button btnLongString;
		internal System.Windows.Forms.Button btnXY;
		internal System.Windows.Forms.Panel pnlDisplay;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DrawStrings()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnLineAlignment = new System.Windows.Forms.Button();
			this.btnAlignment = new System.Windows.Forms.Button();
			this.btnRect = new System.Windows.Forms.Button();
			this.btnLongString = new System.Windows.Forms.Button();
			this.btnXY = new System.Windows.Forms.Button();
			this.pnlDisplay = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// btnLineAlignment
			// 
			this.btnLineAlignment.Font = new System.Drawing.Font("Lucida Sans Unicode", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnLineAlignment.Location = new System.Drawing.Point(8, 136);
			this.btnLineAlignment.Name = "btnLineAlignment";
			this.btnLineAlignment.Size = new System.Drawing.Size(128, 21);
			this.btnLineAlignment.TabIndex = 11;
			this.btnLineAlignment.Text = "LineAlignment";
			this.btnLineAlignment.Click += new System.EventHandler(this.btnLineAlignment_Click);
			// 
			// btnAlignment
			// 
			this.btnAlignment.Font = new System.Drawing.Font("Lucida Sans Unicode", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnAlignment.Location = new System.Drawing.Point(8, 104);
			this.btnAlignment.Name = "btnAlignment";
			this.btnAlignment.Size = new System.Drawing.Size(128, 21);
			this.btnAlignment.TabIndex = 10;
			this.btnAlignment.Text = "Alignment";
			this.btnAlignment.Click += new System.EventHandler(this.btnAlignment_Click);
			// 
			// btnRect
			// 
			this.btnRect.Font = new System.Drawing.Font("Lucida Sans Unicode", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnRect.Location = new System.Drawing.Point(8, 72);
			this.btnRect.Name = "btnRect";
			this.btnRect.Size = new System.Drawing.Size(128, 21);
			this.btnRect.TabIndex = 9;
			this.btnRect.Text = "Draw Rectangle";
			this.btnRect.Click += new System.EventHandler(this.btnRect_Click);
			// 
			// btnLongString
			// 
			this.btnLongString.Font = new System.Drawing.Font("Lucida Sans Unicode", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnLongString.Location = new System.Drawing.Point(8, 40);
			this.btnLongString.Name = "btnLongString";
			this.btnLongString.Size = new System.Drawing.Size(128, 21);
			this.btnLongString.TabIndex = 8;
			this.btnLongString.Text = "Draw Long String";
			this.btnLongString.Click += new System.EventHandler(this.btnLongString_Click);
			// 
			// btnXY
			// 
			this.btnXY.Font = new System.Drawing.Font("Lucida Sans Unicode", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnXY.Location = new System.Drawing.Point(8, 8);
			this.btnXY.Name = "btnXY";
			this.btnXY.Size = new System.Drawing.Size(128, 21);
			this.btnXY.TabIndex = 7;
			this.btnXY.Text = "Draw X,Y";
			this.btnXY.Click += new System.EventHandler(this.btnXY_Click);
			// 
			// pnlDisplay
			// 
			this.pnlDisplay.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlDisplay.Location = new System.Drawing.Point(152, 8);
			this.pnlDisplay.Name = "pnlDisplay";
			this.pnlDisplay.Size = new System.Drawing.Size(225, 210);
			this.pnlDisplay.TabIndex = 6;
			// 
			// DrawStrings
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(392, 229);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.btnLineAlignment,
																		  this.btnAlignment,
																		  this.btnRect,
																		  this.btnLongString,
																		  this.btnXY,
																		  this.pnlDisplay});
			this.Name = "DrawStrings";
			this.Text = "Drawing Strings";
			this.ResumeLayout(false);

		}
		
		Font myFont = new Font("Tahoma", 11, FontStyle.Regular);
		Brush myBrush = new SolidBrush(Color.FromKnownColor(KnownColor.Black));
		#endregion

		private void btnXY_Click(object sender, System.EventArgs e)
		{
			Graphics myGrfx = this.pnlDisplay.CreateGraphics();
			myGrfx.Clear(Color.FromKnownColor(KnownColor.Control));
			myGrfx.DrawString("This is my first string", myFont, myBrush, 5, 5);
		}

		private void btnLongString_Click(object sender, System.EventArgs e)
		{
			Graphics myGrfx = this.pnlDisplay.CreateGraphics();
			myGrfx.Clear(Color.FromKnownColor(KnownColor.Control));
			myGrfx.DrawString("This is a really really long string that will not wrap", myFont, myBrush, 5, 5);
		}

		private void btnRect_Click(object sender, System.EventArgs e)
		{
			RectangleF myRect = new RectangleF(10, 10, 200, 200);
			Graphics myGrfx = this.pnlDisplay.CreateGraphics();
			myGrfx.Clear(Color.FromKnownColor(KnownColor.Control));
			myGrfx.DrawString("This is a really really long string that will wrap", myFont, myBrush, myRect);

		}

		private void btnAlignment_Click(object sender, System.EventArgs e)
		{
			Graphics myGrfx = this.pnlDisplay.CreateGraphics();
			RectangleF myRect = new RectangleF(10, 10, 200, 200);
			StringFormat mySF = new StringFormat();

			myGrfx.Clear(Color.FromKnownColor(KnownColor.Control));

			mySF.Alignment = StringAlignment.Center;
			myGrfx.DrawString("Center", myFont, myBrush, myRect, mySF);

			mySF.Alignment = StringAlignment.Far;
			myGrfx.DrawString("Far", myFont, myBrush, myRect, mySF);

			mySF.Alignment = StringAlignment.Near;
			myGrfx.DrawString("Near", myFont, myBrush, myRect, mySF);

		}

		private void btnLineAlignment_Click(object sender, System.EventArgs e)
		{
			Graphics myGrfx = this.pnlDisplay.CreateGraphics();
			RectangleF myRect = new RectangleF(10, 10, 200, 200);
			StringFormat mySF = new StringFormat();

			myGrfx.Clear(Color.FromKnownColor(KnownColor.Control));

			mySF.LineAlignment = StringAlignment.Center;
			myGrfx.DrawString("Center", myFont, myBrush, myRect, mySF);

			mySF.LineAlignment = StringAlignment.Far;
			myGrfx.DrawString("Far", myFont, myBrush, myRect, mySF);

			mySF.LineAlignment = StringAlignment.Near;
			myGrfx.DrawString("Near", myFont, myBrush, myRect, mySF);

		}
	}
}
