using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ListControlsCSharp
{
	/// <summary>
	/// Summary description for LinkedListboxes.
	/// </summary>
	public class LinkedListboxes : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Button btnSelectAll;
		internal System.Windows.Forms.Button btnDeselectAll;
		internal System.Windows.Forms.Button btnDeSelect;
		internal System.Windows.Forms.Button btnSelect;
		internal System.Windows.Forms.ListBox lbSelected;
		internal System.Windows.Forms.ListBox lbUnselected;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public LinkedListboxes()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.lbUnselected.Items.Add("Item One");
			this.lbUnselected.Items.Add("Item Two");
			this.lbUnselected.Items.Add("Item Three");
			this.lbUnselected.Items.Add("Item Four");
			this.lbUnselected.Items.Add("Item Five");
			this.lbUnselected.Items.Add("Item Six");
			this.lbUnselected.Items.Add("Item Seven");
			this.lbUnselected.Items.Add("Item Eight");
			this.lbUnselected.Items.Add("Item Nine");
			this.lbUnselected.Items.Add("Item Ten");
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		[STAThread]
		static void Main() 
		{
			Application.Run(new LinkedListboxes());
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnSelectAll = new System.Windows.Forms.Button();
			this.btnDeselectAll = new System.Windows.Forms.Button();
			this.btnDeSelect = new System.Windows.Forms.Button();
			this.btnSelect = new System.Windows.Forms.Button();
			this.lbSelected = new System.Windows.Forms.ListBox();
			this.lbUnselected = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// btnSelectAll
			// 
			this.btnSelectAll.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnSelectAll.Location = new System.Drawing.Point(200, 56);
			this.btnSelectAll.Name = "btnSelectAll";
			this.btnSelectAll.Size = new System.Drawing.Size(48, 23);
			this.btnSelectAll.TabIndex = 12;
			this.btnSelectAll.Text = ">>";
			this.btnSelectAll.Click += new System.EventHandler(this.btnSelectAll_Click);
			// 
			// btnDeselectAll
			// 
			this.btnDeselectAll.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnDeselectAll.Location = new System.Drawing.Point(200, 128);
			this.btnDeselectAll.Name = "btnDeselectAll";
			this.btnDeselectAll.Size = new System.Drawing.Size(48, 23);
			this.btnDeselectAll.TabIndex = 11;
			this.btnDeselectAll.Text = "<<";
			this.btnDeselectAll.Click += new System.EventHandler(this.btnDeselectAll_Click);
			// 
			// btnDeSelect
			// 
			this.btnDeSelect.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnDeSelect.Location = new System.Drawing.Point(200, 96);
			this.btnDeSelect.Name = "btnDeSelect";
			this.btnDeSelect.Size = new System.Drawing.Size(48, 23);
			this.btnDeSelect.TabIndex = 10;
			this.btnDeSelect.Text = "<";
			this.btnDeSelect.Click += new System.EventHandler(this.btnDeSelect_Click);
			// 
			// btnSelect
			// 
			this.btnSelect.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnSelect.Location = new System.Drawing.Point(200, 24);
			this.btnSelect.Name = "btnSelect";
			this.btnSelect.Size = new System.Drawing.Size(48, 23);
			this.btnSelect.TabIndex = 9;
			this.btnSelect.Text = ">";
			this.btnSelect.Click += new System.EventHandler(this.btnSelect_Click);
			// 
			// lbSelected
			// 
			this.lbSelected.Location = new System.Drawing.Point(256, 16);
			this.lbSelected.Name = "lbSelected";
			this.lbSelected.Size = new System.Drawing.Size(176, 147);
			this.lbSelected.TabIndex = 8;
			// 
			// lbUnselected
			// 
			this.lbUnselected.Location = new System.Drawing.Point(16, 16);
			this.lbUnselected.Name = "lbUnselected";
			this.lbUnselected.Size = new System.Drawing.Size(176, 147);
			this.lbUnselected.TabIndex = 7;
			// 
			// LinkedListboxes
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(448, 197);
			this.Controls.Add(this.btnSelectAll);
			this.Controls.Add(this.btnDeselectAll);
			this.Controls.Add(this.btnDeSelect);
			this.Controls.Add(this.btnSelect);
			this.Controls.Add(this.lbSelected);
			this.Controls.Add(this.lbUnselected);
			this.Name = "LinkedListboxes";
			this.Text = "LinkedListboxes";
			this.ResumeLayout(false);

		}
		#endregion

		private void btnSelect_Click(object sender, System.EventArgs e)
		{
			if (this.lbUnselected.SelectedItem != null)
			{
				object item = this.lbUnselected.SelectedItem;
				this.lbSelected.Items.Add(item);
				this.lbUnselected.Items.Remove(item);
			}
				
		}

		private void btnSelectAll_Click(object sender, System.EventArgs e)
		{
			foreach (object item in this.lbUnselected.Items)
				this.lbSelected.Items.Add(item);
			this.lbUnselected.Items.Clear();

		}

		private void btnDeSelect_Click(object sender, System.EventArgs e)
		{
			if (this.lbSelected.SelectedItem != null)
			{
				object item = this.lbSelected.SelectedItem;
				this.lbUnselected.Items.Add(item);
				this.lbSelected.Items.Remove(item);
			}
		}

		private void btnDeselectAll_Click(object sender, System.EventArgs e)
		{
			foreach (object item in this.lbSelected.Items)
				this.lbUnselected.Items.Add(item);
			this.lbSelected.Items.Clear();
		}
	}
}
