using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ListControlsCSharp
{
	/// <summary>
	/// Summary description for ListViewExample.
	/// </summary>
	public class ListViewExample : System.Windows.Forms.Form
	{
		internal System.Data.OleDb.OleDbConnection cnGrids;
		internal System.Windows.Forms.ImageList smallImages;
		internal System.Windows.Forms.ImageList largeImages;
		internal System.Data.OleDb.OleDbDataAdapter daReps;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		internal System.Data.OleDb.OleDbDataAdapter daCustomers;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand2;
		private ListControlsCSharp.dsMaster dsFrmMaster;
		internal System.Windows.Forms.ListView myListView;
		internal System.Windows.Forms.RadioButton rbLargeIcon;
		internal System.Windows.Forms.RadioButton rbSmallIcon;
		internal System.Windows.Forms.RadioButton rbList;
		internal System.Windows.Forms.RadioButton rbDetails;
		private System.ComponentModel.IContainer components;

		public ListViewExample()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			try
			{
				this.daReps.Fill(this.dsFrmMaster.Representatives);
				this.daCustomers.Fill(this.dsFrmMaster.CustomerList);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}

			AddRows();

			this.myListView.Columns.Add("Customer Name", -2, HorizontalAlignment.Left);
            this.myListView.Columns.Add("ID", 45, HorizontalAlignment.Center);
            this.myListView.Columns.Add("Representative", 145, HorizontalAlignment.Left);

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ListViewExample));
			this.cnGrids = new System.Data.OleDb.OleDbConnection();
			this.smallImages = new System.Windows.Forms.ImageList(this.components);
			this.largeImages = new System.Windows.Forms.ImageList(this.components);
			this.daReps = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.daCustomers = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand2 = new System.Data.OleDb.OleDbCommand();
			this.dsFrmMaster = new ListControlsCSharp.dsMaster();
			this.myListView = new System.Windows.Forms.ListView();
			this.rbLargeIcon = new System.Windows.Forms.RadioButton();
			this.rbSmallIcon = new System.Windows.Forms.RadioButton();
			this.rbList = new System.Windows.Forms.RadioButton();
			this.rbDetails = new System.Windows.Forms.RadioButton();
			((System.ComponentModel.ISupportInitialize)(this.dsFrmMaster)).BeginInit();
			this.SuspendLayout();
			// 
			// cnGrids
			// 
			this.cnGrids.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\Grids.mdb"";Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// smallImages
			// 
			this.smallImages.ImageSize = new System.Drawing.Size(16, 16);
			this.smallImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("smallImages.ImageStream")));
			this.smallImages.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// largeImages
			// 
			this.largeImages.ImageSize = new System.Drawing.Size(24, 23);
			this.largeImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("largeImages.ImageStream")));
			this.largeImages.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// daReps
			// 
			this.daReps.SelectCommand = this.OleDbSelectCommand1;
			this.daReps.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																							 new System.Data.Common.DataTableMapping("Table", "Representatives", new System.Data.Common.DataColumnMapping[] {
																																																				new System.Data.Common.DataColumnMapping("RepID", "RepID"),
																																																				new System.Data.Common.DataColumnMapping("RepName", "RepName")})});
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT * FROM Representatives";
			this.OleDbSelectCommand1.Connection = this.cnGrids;
			// 
			// daCustomers
			// 
			this.daCustomers.SelectCommand = this.OleDbSelectCommand2;
			this.daCustomers.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								  new System.Data.Common.DataTableMapping("Table", "CustomerList", new System.Data.Common.DataColumnMapping[] {
																																																				  new System.Data.Common.DataColumnMapping("CustomerID", "CustomerID"),
																																																				  new System.Data.Common.DataColumnMapping("CustomerName", "CustomerName"),
																																																				  new System.Data.Common.DataColumnMapping("RepID", "RepID")})});
			// 
			// OleDbSelectCommand2
			// 
			this.OleDbSelectCommand2.CommandText = "SELECT * FROM CustomerList";
			this.OleDbSelectCommand2.Connection = this.cnGrids;
			// 
			// dsFrmMaster
			// 
			this.dsFrmMaster.DataSetName = "dsMaster";
			this.dsFrmMaster.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// myListView
			// 
			this.myListView.AllowColumnReorder = true;
			this.myListView.LargeImageList = this.largeImages;
			this.myListView.Location = new System.Drawing.Point(8, 39);
			this.myListView.Name = "myListView";
			this.myListView.Size = new System.Drawing.Size(344, 216);
			this.myListView.SmallImageList = this.smallImages;
			this.myListView.TabIndex = 6;
			this.myListView.View = System.Windows.Forms.View.Details;
			this.myListView.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.myListView_ColumnClick);
			// 
			// rbLargeIcon
			// 
			this.rbLargeIcon.Appearance = System.Windows.Forms.Appearance.Button;
			this.rbLargeIcon.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbLargeIcon.Location = new System.Drawing.Point(8, 7);
			this.rbLargeIcon.Name = "rbLargeIcon";
			this.rbLargeIcon.Size = new System.Drawing.Size(80, 24);
			this.rbLargeIcon.TabIndex = 5;
			this.rbLargeIcon.Text = "Large Icon";
			this.rbLargeIcon.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.rbLargeIcon.CheckedChanged += new System.EventHandler(this.rbLargeIcon_CheckedChanged);
			// 
			// rbSmallIcon
			// 
			this.rbSmallIcon.Appearance = System.Windows.Forms.Appearance.Button;
			this.rbSmallIcon.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbSmallIcon.Location = new System.Drawing.Point(96, 7);
			this.rbSmallIcon.Name = "rbSmallIcon";
			this.rbSmallIcon.Size = new System.Drawing.Size(80, 24);
			this.rbSmallIcon.TabIndex = 4;
			this.rbSmallIcon.Text = "Small Icon";
			this.rbSmallIcon.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.rbSmallIcon.CheckedChanged += new System.EventHandler(this.rbSmallIcon_CheckedChanged);
			// 
			// rbList
			// 
			this.rbList.Appearance = System.Windows.Forms.Appearance.Button;
			this.rbList.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbList.Location = new System.Drawing.Point(184, 7);
			this.rbList.Name = "rbList";
			this.rbList.Size = new System.Drawing.Size(80, 24);
			this.rbList.TabIndex = 2;
			this.rbList.Text = "List";
			this.rbList.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.rbList.CheckedChanged += new System.EventHandler(this.rbList_CheckedChanged);
			// 
			// rbDetails
			// 
			this.rbDetails.Appearance = System.Windows.Forms.Appearance.Button;
			this.rbDetails.Checked = true;
			this.rbDetails.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbDetails.Location = new System.Drawing.Point(272, 7);
			this.rbDetails.Name = "rbDetails";
			this.rbDetails.Size = new System.Drawing.Size(80, 24);
			this.rbDetails.TabIndex = 3;
			this.rbDetails.TabStop = true;
			this.rbDetails.Text = "Details";
			this.rbDetails.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.rbDetails.CheckedChanged += new System.EventHandler(this.rbDetails_CheckedChanged);
			// 
			// ListViewExample
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(360, 262);
			this.Controls.Add(this.myListView);
			this.Controls.Add(this.rbLargeIcon);
			this.Controls.Add(this.rbSmallIcon);
			this.Controls.Add(this.rbList);
			this.Controls.Add(this.rbDetails);
			this.Name = "ListViewExample";
			this.Text = "ListViewExample";
			((System.ComponentModel.ISupportInitialize)(this.dsFrmMaster)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
		[STAThread]
		static void Main() 
		{
			Application.Run(new ListViewExample());
		}

		private void AddRows()
		{
			ListViewItem lvi;

			foreach (dsMaster.CustomerListRow dr in this.dsFrmMaster.CustomerList)
			{
				lvi = new ListViewItem();
				lvi.ImageIndex = 0;
				lvi.Text = dr.CustomerName;
				lvi.SubItems.Add(dr.CustomerID.ToString());
				lvi.SubItems.Add((string)dr.GetParentRow("RepCustomers")["RepName"]);

				this.myListView.Items.Add(lvi);
			}
		}

		private void myListView_ColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e)
		{
			this.myListView.ListViewItemSorter = new mySorter(e.Column);
			this.myListView.Sort();
		}

		private void rbLargeIcon_CheckedChanged(object sender, System.EventArgs e)
		{
			this.myListView.View = View.LargeIcon;
		}

		private void rbSmallIcon_CheckedChanged(object sender, System.EventArgs e)
		{
			this.myListView.View = View.SmallIcon;
		}

		private void rbList_CheckedChanged(object sender, System.EventArgs e)
		{
			this.myListView.View = View.List;
		}

		private void rbDetails_CheckedChanged(object sender, System.EventArgs e)
		{
			this.myListView.View = View.Details;
		}

		public class mySorter : IComparer
		{
			private int theCol = 0;

			#region IComparer Members

			public mySorter(int col)
			{
				theCol = col;
			}

			public int Compare(object x, object y)
			{
				ListViewItem lvX = (ListViewItem)x;
				ListViewItem lvY = (ListViewItem)y;
				string strX;
				string strY;
				strX = lvX.SubItems[theCol].Text;
				strY = lvY.SubItems[theCol].Text;

				return String.Compare(strX, strY);
			}

			#endregion
		}

	}
}
