using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ListControlsCSharp
{
	/// <summary>
	/// Summary description for TreeView.
	/// </summary>
	public class TreeView : System.Windows.Forms.Form
	{
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand2;
		internal System.Data.OleDb.OleDbConnection cnChapter13;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		private ListControlsCSharp.dsChapter13 dsFrmChapter13;
		internal System.Data.OleDb.OleDbDataAdapter daCustomerList;
		internal System.Data.OleDb.OleDbDataAdapter daRepresentatives;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.TreeView tvOnDemand;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.TreeView tvDetails;
		internal System.Windows.Forms.TreeView tvRelated;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TreeView()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			try
			{
				this.daRepresentatives.Fill(this.dsFrmChapter13, "Representatives");
				this.daCustomerList.Fill(this.dsFrmChapter13, "CustomerList");
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}

			AddRelatedNodes();
			AddDetailNodes();
			AddOnDemand();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		[STAThread]
		static void Main() 
		{
			Application.Run(new TreeView());
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.OleDbSelectCommand2 = new System.Data.OleDb.OleDbCommand();
			this.cnChapter13 = new System.Data.OleDb.OleDbConnection();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.dsFrmChapter13 = new ListControlsCSharp.dsChapter13();
			this.daCustomerList = new System.Data.OleDb.OleDbDataAdapter();
			this.daRepresentatives = new System.Data.OleDb.OleDbDataAdapter();
			this.Label3 = new System.Windows.Forms.Label();
			this.tvOnDemand = new System.Windows.Forms.TreeView();
			this.Label2 = new System.Windows.Forms.Label();
			this.Label1 = new System.Windows.Forms.Label();
			this.tvDetails = new System.Windows.Forms.TreeView();
			this.tvRelated = new System.Windows.Forms.TreeView();
			((System.ComponentModel.ISupportInitialize)(this.dsFrmChapter13)).BeginInit();
			this.SuspendLayout();
			// 
			// OleDbSelectCommand2
			// 
			this.OleDbSelectCommand2.CommandText = "SELECT RepID, RepName FROM Representatives";
			this.OleDbSelectCommand2.Connection = this.cnChapter13;
			// 
			// cnChapter13
			// 
			this.cnChapter13.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\Chapter13.mdb"";Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT CustomerID, CustomerName, RepID FROM CustomerList";
			this.OleDbSelectCommand1.Connection = this.cnChapter13;
			// 
			// dsFrmChapter13
			// 
			this.dsFrmChapter13.DataSetName = "dsChapter13";
			this.dsFrmChapter13.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// daCustomerList
			// 
			this.daCustomerList.SelectCommand = this.OleDbSelectCommand1;
			this.daCustomerList.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									 new System.Data.Common.DataTableMapping("Table", "CustomerList", new System.Data.Common.DataColumnMapping[] {
																																																					 new System.Data.Common.DataColumnMapping("CustomerID", "CustomerID"),
																																																					 new System.Data.Common.DataColumnMapping("CustomerName", "CustomerName"),
																																																					 new System.Data.Common.DataColumnMapping("RepID", "RepID")})});
			// 
			// daRepresentatives
			// 
			this.daRepresentatives.SelectCommand = this.OleDbSelectCommand2;
			this.daRepresentatives.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																										new System.Data.Common.DataTableMapping("Table", "Representatives", new System.Data.Common.DataColumnMapping[] {
																																																						   new System.Data.Common.DataColumnMapping("RepID", "RepID"),
																																																						   new System.Data.Common.DataColumnMapping("RepName", "RepName")})});
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Location = new System.Drawing.Point(392, 10);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(65, 16);
			this.Label3.TabIndex = 11;
			this.Label3.Text = "OnDemand:";
			// 
			// tvOnDemand
			// 
			this.tvOnDemand.ImageIndex = -1;
			this.tvOnDemand.Location = new System.Drawing.Point(384, 26);
			this.tvOnDemand.Name = "tvOnDemand";
			this.tvOnDemand.SelectedImageIndex = -1;
			this.tvOnDemand.Size = new System.Drawing.Size(168, 200);
			this.tvOnDemand.TabIndex = 10;
			this.tvOnDemand.BeforeExpand += new System.Windows.Forms.TreeViewCancelEventHandler(this.tvOnDemand_BeforeExpand);
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Location = new System.Drawing.Point(24, 10);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(84, 16);
			this.Label2.TabIndex = 9;
			this.Label2.Text = "Related Tables:";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(208, 10);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(42, 16);
			this.Label1.TabIndex = 8;
			this.Label1.Text = "Details:";
			// 
			// tvDetails
			// 
			this.tvDetails.ImageIndex = -1;
			this.tvDetails.Location = new System.Drawing.Point(200, 26);
			this.tvDetails.Name = "tvDetails";
			this.tvDetails.SelectedImageIndex = -1;
			this.tvDetails.Size = new System.Drawing.Size(168, 200);
			this.tvDetails.TabIndex = 7;
			// 
			// tvRelated
			// 
			this.tvRelated.ImageIndex = -1;
			this.tvRelated.Location = new System.Drawing.Point(16, 26);
			this.tvRelated.Name = "tvRelated";
			this.tvRelated.SelectedImageIndex = -1;
			this.tvRelated.Size = new System.Drawing.Size(168, 200);
			this.tvRelated.TabIndex = 6;
			// 
			// TreeView
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(568, 237);
			this.Controls.Add(this.Label3);
			this.Controls.Add(this.tvOnDemand);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.tvDetails);
			this.Controls.Add(this.tvRelated);
			this.Name = "TreeView";
			this.Text = "TreeView";
			((System.ComponentModel.ISupportInitialize)(this.dsFrmChapter13)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
		private void AddRelatedNodes()
		{
			TreeNode tn;

			foreach (dsChapter13.RepresentativesRow drRep in this.dsFrmChapter13.Representatives)
			{
				tn = this.tvRelated.Nodes.Add(drRep.RepName);
				foreach (dsChapter13.CustomerListRow drCust in drRep.GetChildRows("RepresentativesCustomerList"))
					tn.Nodes.Add(drCust.CustomerName);
			}
				
		}

		private void AddDetailNodes()
		{
			TreeNode tn;

			foreach (dsChapter13.CustomerListRow drCust in this.dsFrmChapter13.CustomerList)
			{
				tn = this.tvDetails.Nodes.Add(drCust.CustomerName);
				tn.Nodes.Add("ID:  " + drCust.CustomerID);
				tn.Nodes.Add("Rep:  " + drCust.RepID);
			}
		}

		private void AddOnDemand()
		{
			TreeNode tn;

			foreach (dsChapter13.RepresentativesRow drRep in this.dsFrmChapter13.Representatives)
			{
				tn = this.tvOnDemand.Nodes.Add(drRep.RepName);
				tn.Nodes.Add("#");
			}
		}

		private void tvOnDemand_BeforeExpand(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
			TreeNode tn = e.Node;

			if (tn.Nodes[0].Text == "#")
			{
				tn.Nodes.Clear();

				DataView dv = this.dsFrmChapter13.Representatives.DefaultView;
				dv.Sort = "RepName";

				int idx = dv.Find(tn.Text);
				DataRow drRep = dv[idx].Row;

				foreach (DataRow drCust in drRep.GetChildRows("RepresentativesCustomerList"))
					tn.Nodes.Add((string)drCust["CustomerName"]);
			}
		}
	}
}
