using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Security.Policy;

namespace InterfaceArchitecturesCSharp
{
	/// <summary>
	/// Summary description for Welcome.
	/// </summary>
	public class Welcome : System.Windows.Forms.Form
	{
		string currFormName; //contains the name of the form being displayed
		int currFormIdx; //contains the row index of the current form
		Assembly theEnv; 
		Form theForm; 
		string prevFormName;
		int prevFormIdx;
																 
		internal System.Windows.Forms.Button btnFinish;
		internal System.Windows.Forms.Button btnNext;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand2;
		internal System.Data.OleDb.OleDbConnection cnDecisionTree;
		internal System.Windows.Forms.Button btnBack;
		internal System.Data.OleDb.OleDbDataAdapter daActions;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		internal System.Windows.Forms.PictureBox PictureBox1;
		internal System.Data.OleDb.OleDbDataAdapter daDecisions;
		internal System.Windows.Forms.Button btnCancel;
		private InterfaceArchitecturesCSharp.dsDecisionTree dsFrmDecisionTree;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Welcome()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			theEnv = (AppDomain.CurrentDomain.GetAssemblies())[0];
			theEnv = Assembly.GetAssembly(this.GetType());

			this.daDecisions.Fill(this.dsFrmDecisionTree.Decisions);
			this.daActions.Fill(this.dsFrmDecisionTree.Actions);

			currFormName = this.Name;
			currFormIdx = 0; //this assumes "welcome" is the first row in the dataset

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Welcome));
			this.btnFinish = new System.Windows.Forms.Button();
			this.btnNext = new System.Windows.Forms.Button();
			this.OleDbSelectCommand2 = new System.Data.OleDb.OleDbCommand();
			this.cnDecisionTree = new System.Data.OleDb.OleDbConnection();
			this.btnBack = new System.Windows.Forms.Button();
			this.daActions = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.PictureBox1 = new System.Windows.Forms.PictureBox();
			this.daDecisions = new System.Data.OleDb.OleDbDataAdapter();
			this.btnCancel = new System.Windows.Forms.Button();
			this.dsFrmDecisionTree = new InterfaceArchitecturesCSharp.dsDecisionTree();
			((System.ComponentModel.ISupportInitialize)(this.dsFrmDecisionTree)).BeginInit();
			this.SuspendLayout();
			// 
			// btnFinish
			// 
			this.btnFinish.Location = new System.Drawing.Point(331, 428);
			this.btnFinish.Name = "btnFinish";
			this.btnFinish.TabIndex = 9;
			this.btnFinish.Text = "Finish";
			this.btnFinish.Click += new System.EventHandler(this.btnFinish_Click);
			// 
			// btnNext
			// 
			this.btnNext.Location = new System.Drawing.Point(251, 428);
			this.btnNext.Name = "btnNext";
			this.btnNext.TabIndex = 8;
			this.btnNext.Text = "Next >";
			this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
			// 
			// OleDbSelectCommand2
			// 
			this.OleDbSelectCommand2.CommandText = "SELECT ControlName, DecisionID, FormName FROM Decisions";
			this.OleDbSelectCommand2.Connection = this.cnDecisionTree;
			// 
			// cnDecisionTree
			// 
			this.cnDecisionTree.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\DecisionTree.mdb"";Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// btnBack
			// 
			this.btnBack.Enabled = false;
			this.btnBack.Location = new System.Drawing.Point(171, 428);
			this.btnBack.Name = "btnBack";
			this.btnBack.TabIndex = 7;
			this.btnBack.Text = "< Back";
			// 
			// daActions
			// 
			this.daActions.SelectCommand = this.OleDbSelectCommand1;
			this.daActions.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								new System.Data.Common.DataTableMapping("Table", "Actions", new System.Data.Common.DataColumnMapping[] {
																																																		   new System.Data.Common.DataColumnMapping("ActionID", "ActionID"),
																																																		   new System.Data.Common.DataColumnMapping("DecisionID", "DecisionID"),
																																																		   new System.Data.Common.DataColumnMapping("Result", "Result"),
																																																		   new System.Data.Common.DataColumnMapping("ScreenToDisplay", "ScreenToDisplay")})});
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT ActionID, DecisionID, Result, ScreenToDisplay FROM Actions";
			this.OleDbSelectCommand1.Connection = this.cnDecisionTree;
			// 
			// PictureBox1
			// 
			this.PictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("PictureBox1.Image")));
			this.PictureBox1.Location = new System.Drawing.Point(19, 12);
			this.PictureBox1.Name = "PictureBox1";
			this.PictureBox1.Size = new System.Drawing.Size(360, 392);
			this.PictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.PictureBox1.TabIndex = 5;
			this.PictureBox1.TabStop = false;
			// 
			// daDecisions
			// 
			this.daDecisions.SelectCommand = this.OleDbSelectCommand2;
			this.daDecisions.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								  new System.Data.Common.DataTableMapping("Table", "Decisions", new System.Data.Common.DataColumnMapping[] {
																																																			   new System.Data.Common.DataColumnMapping("ControlName", "ControlName"),
																																																			   new System.Data.Common.DataColumnMapping("DecisionID", "DecisionID"),
																																																			   new System.Data.Common.DataColumnMapping("FormName", "FormName")})});
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(91, 428);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 6;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// dsFrmDecisionTree
			// 
			this.dsFrmDecisionTree.DataSetName = "dsDecisionTree";
			this.dsFrmDecisionTree.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// Welcome
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(424, 462);
			this.Controls.Add(this.PictureBox1);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnFinish);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.btnBack);
			this.Name = "Welcome";
			this.Text = "Welcome";
			((System.ComponentModel.ISupportInitialize)(this.dsFrmDecisionTree)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Welcome());
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btnFinish_Click(object sender, System.EventArgs e)
		{
			DoFinish();
		}

		private void DoFinish()
		{
			dsDecisionTree.DecisionsRow drD;
			DataView dvD = new DataView(dsFrmDecisionTree.Decisions);
			int idx;
			string nextForm;
			Form theForm;

			//find the correct row in the decisions table
	        dvD.Sort = "ControlName";
			idx = dvD.Find("Done");
			drD = dvD[idx].Row as dsDecisionTree.DecisionsRow;
			nextForm = drD.FormName;

			//show the new form
			Type formType = theEnv.GetType("InterfaceArchitecturesCSharp." + nextForm);
			theForm = theEnv.CreateInstance(formType.FullName) as Form;

			theForm.ShowDialog();

			// dispose of the form and exit
			string theResult;
			theResult = (string)theForm.Tag;
			theForm.Dispose();
			this.Close();
		}

		private void btnNext_Click(object sender, System.EventArgs e)
		{
			GoForward();
		}

		private void GoForward()
		{
			dsDecisionTree.DecisionsRow drD;
			DataView dvD = new DataView(dsFrmDecisionTree.Decisions);
			dsDecisionTree.ActionsRow drA;
			DataView dvA = new DataView(dsFrmDecisionTree.Actions);
			int idx = 0;
	        string nextForm = currFormName;


			//hide this form, if necessary
			if (this.Visible)
				this.Hide();

			//find the correct row in the decision table
			drD = dvD[currFormIdx].Row as dsDecisionTree.DecisionsRow;

			switch (drD.ControlName)
			{
				case "Any":  //no decision to be made - go to next form

					//find the correct row in the actions table
					dvA.Sort = "DecisionID";
					idx = dvA.Find(drD.DecisionID);
					drA = dvA[idx].Row as dsDecisionTree.ActionsRow;

					//find the new form in the decisions table
					dsDecisionTree.DecisionsRow nextRow;
					dvD.Sort = "DecisionID";
					idx = dvD.Find(drA.ScreenToDisplay);
					nextRow = dvD[idx].Row as dsDecisionTree.DecisionsRow;
					nextForm = nextRow.FormName;
					break;
				case "Finish":
					this.Close();
					break;
				default:  //choose the next form based on the value returned
					string[] theValue = new string[2];

					//determine the value chosen by the user
					//in the sample, the control is always a listbox
					theValue[0] = drD.DecisionID.ToString();
					theValue[1] = theForm.Tag.ToString();

					//find the correct row in the actions table
					dvA.Sort = "DecisionID, Result";
					idx = dvA.Find(theValue);
					drA = dvA[idx].Row as dsDecisionTree.ActionsRow;

					//find the new form in the decisions table
					dvD.Sort = "DecisionID";
					idx = dvD.Find(drA.ScreenToDisplay);
					nextRow = dvD[idx].Row as dsDecisionTree.DecisionsRow;
					nextForm = nextRow.FormName;
					break;
			}

			//re-set the tracking variables
			prevFormName = currFormName;
			currFormName = nextForm;
			prevFormIdx = currFormIdx;
			currFormIdx = idx;

			//show the new form
			Type formType;
			formType = theEnv.GetType("InterfaceArchitecturesCSharp." + nextForm);
			theForm = theEnv.CreateInstance(formType.FullName) as Form;

			theForm.ShowDialog();

			// dispose of the form and determine the next action
			string theResult;
			theResult = theForm.Tag.ToString();
			theForm.Dispose();
			WhatNext(theResult);
		}

		private void WhatNext(string theResult)
		{
			switch (theResult)
			{
				case "Cancel":
					this.Close();
					break;
				case "Back":
					GoBack();
					break;
				case "Finish":
					DoFinish();
					break;
				case "Done":
					DoFinish();
					break;
				default:
					GoForward();
					break;
			}

		}

		private void GoBack()
		{
			//show the form
			if (currFormName == "Welcome")
				this.Show();
			else
			{
				Type formType;
				Form theForm;

				formType = theEnv.GetType("InterfaceArchitecturesCSharp." + prevFormName);
				theForm = theEnv.CreateInstance(formType.FullName) as Form;

				theForm.ShowDialog();

				//dispose of the form and determine the next action
				string theResult;
				theResult = theForm.Tag.ToString();
				theForm.Dispose();


				currFormName = prevFormName;
				currFormIdx = prevFormIdx;
			}
		}
	}
}
